#include "fstress.h"

void *doit(void *_args)
{
	struct doit_args *args = _args;
	unsigned int iter ;
	unsigned int elem ;
	unsigned int low, high ;
	int thrd ;
	double a, b, c, d ;
	int errflag = 0;

	thrd = args->thrd_num;
	pr_info("thread %d nelems %u wspace[%d] = %p\n",
		thrd, nelem, thrd, wspace[thrd]);

	pthread_barrier_wait(args->barrier);

	thrdres[thrd] = 0.0 ;
	for  (iter = 0; iter < niter; iter++)  {
		for  (elem = 0 ; elem < nelem; elem++)  {
			errflag = 0 ;
			low = mod(elem-iter, nelem);
			high = mod(elem+iter, nelem);

			if (low >= nelem) {
				pr_info("low %u is too big\n", low);
				exit(1);
			}

			if (high >= nelem) {
				pr_info("hight %u is too big\n", low);
				exit(1);
			}

			a = (double)wspace[thrd][elem];
			b = (double)wspace[thrd][low];
			c = (double)wspace[thrd][high];

			if  (a != (double)1.0)  {
				errflag = 1 ;
				pr_info("iteration %d, reading element %4d = %15.12f\n",
					iter, elem, a) ;
			}

			if  (b != (double)1.0)  {
				errflag = 1 ;
				pr_info("iteration %d, reading element %4d = %15.12f\n",
					iter, low, b) ;
			}

			if  (c != (double)1.0)  {
				errflag = 1 ;
				pr_info("iteration %d, reading element %4d = %15.12f\n",
					iter, high, c) ;
			}

			d = (double)(a + b + c) / (double)3.0 ;
			if  (d != (double)1.0)  {
				errflag = 1 ;
				pr_info("iteration %d, computed element %4d = %15.12f (%15.12f %15.12f %15.12f)\n",
					iter, elem, d, a, b, c) ;
			}
#if 1
			wspace[thrd][elem] = (wspace[thrd][elem] + wspace[thrd][low] +
					      wspace[thrd][high]) / 3.0 ;
#endif
			a = wspace[thrd][elem] ;
			if  (a != (double)1.0)  {
				errflag = 1 ;
				pr_info("iteration %d, RE-reading element a %4d = %15.12f (%15.12f %15.12f %15.12f)\n",
					iter, elem, a, wspace[thrd][elem], wspace[thrd][low], wspace[thrd][high]) ;
			}
			b = wspace[thrd][low] ;
			c = wspace[thrd][high] ;
			if  (b != (double)1.0)  {
				errflag = 1 ;
				pr_info("iteration %d, RE-reading element b %4d = %15.12f\n",
					iter, low, b) ;
			}
			if  (c != (double)1.0)  {
				errflag = 1 ;
				pr_info("iteration %d, RE-reading element c %4d = %15.12f\n",
					iter, high, c) ;
			}

			if  (errflag)
				return NULL;
		}
	}

	for  (elem = 0 ; elem < nelem ; elem++)
		thrdres[thrd] = thrdres[thrd] + (double)wspace[thrd][elem] ;

	thrdres[thrd] = thrdres[thrd] / (double)nelem ;

	return NULL;
}
